<?php

header('Content-Type: application/json');

require("conexion.php");

$_GET['oracion'] = eliminarAcentos($_GET['oracion']);
$_GET['oracion'] = strtolower($_GET['oracion']);

//Tablas que se pueden analizar
$tablas = array("clientes", "productos", "facturas", "categorias");
$tablaconsulta = "";
$palabras = explode(" ", $_GET['oracion']);
foreach ($palabras as $palabra) {
    if (in_array($palabra, $tablas)) {
        $tablaconsulta = $palabra;
    }
}

quePuedoPreguntar();

require("reconocimiento/facturas.php");
consultasSobreFacturas();
require("reconocimiento/clientes.php");
consultasSobreClientes();
require("reconocimiento/productos.php");
consultasSobreProductos();

switch ($tablaconsulta) {
    case 'clientes':
        clientes();
        break;

    case 'productos':
        productos();
        break;

    case 'categorias':
        categorias();
        break;

    case 'facturas':
        facturas();
        break;
}

//------------------ Fin del bloque principal del programa --------------------------------------//

function quePuedoPreguntar()
{
    if ($_GET['oracion'] == 'que puedo preguntar') {
        mostrarPreguntas();
    }
    if ($_GET['oracion'] == 'que puedo preguntar de clientes') {
        mostrarPreguntasClientes();
    }
    if ($_GET['oracion'] == 'que puedo preguntar de productos') {
        mostrarPreguntasProductos();
    }
}

function clientes()
{
    $conexion = retornarConexion();
    $datos = mysqli_query($conexion, "select codigo,nombre,telefono,mail,direccion from clientes");
    $resultado = mysqli_fetch_all($datos, MYSQLI_ASSOC);
    echo json_encode($resultado);
}

function productos()
{
    $conexion = retornarConexion();
    $datos = mysqli_query($conexion, "select pro.codigo as `codigo de producto`,
                                             pro.descripcion as `descripcion de producto`,
                                             precio,
                                             ca.descripcion as categoria
                                           from productos as pro
                                           join categorias as ca on ca.codigo=pro.codigocategoria");
    $resultado = mysqli_fetch_all($datos, MYSQLI_ASSOC);
    echo json_encode($resultado);
}

function categorias()
{
    $conexion = retornarConexion();
    $datos = mysqli_query($conexion, "select codigo,descripcion from categorias");
    $resultado = mysqli_fetch_all($datos, MYSQLI_ASSOC);
    echo json_encode($resultado);
}

function facturas()
{
    $conexion = retornarConexion();
    $datos = mysqli_query($conexion, "
    select 
              fact.codigo as codigo,
              date_format(fecha,'%d/%m/%Y') as fecha,
              nombre,
              round(sum(deta.precio*deta.cantidad),2) as importefactura
          from facturas as fact 
          join clientes as cli on cli.codigo=fact.codigocliente
          join detallefactura as deta on deta.codigofactura=fact.codigo
          group by deta.codigofactura
          order by codigo desc");
    $resultado = mysqli_fetch_all($datos, MYSQLI_ASSOC);
    echo json_encode($resultado);
}

function mostrarPreguntas()
{
    echo '
    [{"pregunta":"\"que puedo preguntar\""},
     {"pregunta":"listado de \"productos\""},
     {"pregunta":"listado de \"clientes\""},
     {"pregunta":"listado de \"facturas\""},
     {"pregunta":"listado de \"categorias\""},
     {"pregunta":"\"factura de\" (apellido y nombre)"},
     {"pregunta":"\"facturas de\" (apellido y nombre)"},
     {"pregunta":"\"factura con importe menor a\" (importe)"},
     {"pregunta":"\"facturas con importe menor a\" (importe)"},
     {"pregunta":"\"factura con importe mayor a\" (importe)"},
     {"pregunta":"\"facturas con importe mayor a\" (importe)"},      
     {"pregunta":"\"factura numero \" (numero)"},
     {"pregunta":"\"facturas numero \" (numero)"},
     {"pregunta":"\"mail de\" (apellido y nombre)"},
     {"pregunta":"\"telefono de\" (apellido y nombre)"},
     {"pregunta":"\"direccion de\" (apellido y nombre)"},          
     {"pregunta":"\"todos los datos de\" (apellido y nombre)"},
     {"pregunta":"\"producto numero\" (numero)"},
     {"pregunta":"\"precios de\" (nombre de cateroría)"}
    ]';
    exit(0);
}


function mostrarPreguntasClientes()
{
    echo '
    [
     {"pregunta":"listado de \"clientes\""},
     {"pregunta":"\"factura de\" (apellido y nombre)"},
     {"pregunta":"\"facturas de\" (apellido y nombre)"},
     {"pregunta":"\"mail de\" (apellido y nombre)"},
     {"pregunta":"\"telefono de\" (apellido y nombre)"},
     {"pregunta":"\"direccion de\" (apellido y nombre)"},     
     {"pregunta":"\"todos los datos de\" (apellido y nombre)"}
    ]';
    exit(0);
}

function mostrarPreguntasProductos()
{
    echo '
    [
        {"pregunta":"\"producto numero\" (numero)"},
        {"pregunta":"\"precios de\" (nombre de cateroría)"}   
    ]';
    exit(0);
}

function eliminarAcentos($oracion)
{
    $oracion = str_replace('á', 'a', $oracion);
    $oracion = str_replace('é', 'e', $oracion);
    $oracion = str_replace('í', 'i', $oracion);
    $oracion = str_replace('ó', 'o', $oracion);
    $oracion = str_replace('ú', 'u', $oracion);
    return $oracion;
}
